/**
 *  joola.io
 *
 *  Copyright Joola Smart Solutions, Ltd. <info@joo.la>
 *
 *  Licensed under GNU General Public License 3.0 or later.
 *  Some rights reserved. See LICENSE, AUTHORS.
 *
 *  @license GPL-3.0+ <http://spdx.org/licenses/GPL-3.0+>
 */


var
  joola = global.joola, //for jslint
  ce = require('cloneextend');

var list = function () {
  var auth = joola.config.authentication;
  var orgs = auth.organizations;

  _.each(orgs, function (org) {
    orgs.push(org);
  });

  return ce.clone(orgs);
};

var get = function (id) {
  var orgs = this.list();
  return ce.clone(_.find(orgs, function (org) {
    return org.id.toLowerCase() == id.toLowerCase();
  }));
};

exports.list = list;
exports.get = get;
