/**
 *  joola.io
 *
 *  Copyright Joola Smart Solutions, Ltd. <info@joo.la>
 *
 *  Licensed under GNU General Public License 3.0 or later.
 *  Some rights reserved. See LICENSE, AUTHORS.
 *
 *  @license GPL-3.0+ <http://spdx.org/licenses/GPL-3.0+>
 */


var
  joola = global.joola, //for jslint
  url = require('url'),
  ce = require('cloneextend'),
  _orgs = require('./orgs');

var list = function () {
  var roles = [];
  var _roles = joola.config.authentication.roles;
  var orgs = _orgs.list();

  _.each(_roles, function (role) {
    if (role.id && role.id != '' && role.id != null)
      roles.push(role);
  });

  _.each(orgs, function (org) {
    _.each(org.roles, function (role) {
      if (role.id && role.id != '' && role.id != null)
        roles.push(role);
    })
  });

  return ce.clone(roles);
};

var get = function (id) {
  var roles = this.list();
  return ce.clone(_.find(roles, function (role) {
    return role.id.toLowerCase() == id.toLowerCase();
  }));
};

exports.list = list;
exports.get = get;
